//+------------------------------------------------------------------+
//|                                                  Taitongtan2.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Magenta  
#property indicator_color2  Yellow
#property indicator_color3  Aqua


extern int period=12; 
extern int builtinShift=5; 



double firstLineBuf[];
double secondLineBuf[];
double thirdLineBuf[];


void init()
{       
 IndicatorBuffers(3);
 SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 1);
 SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 1);
 SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 1);
 
 SetIndexShift(0, builtinShift);
 SetIndexShift(1, builtinShift);
 
 
 IndicatorShortName("Taitongtan("+period+")");
 
  
 
 SetIndexBuffer(0, firstLineBuf);
 SetIndexBuffer(1, secondLineBuf);
 SetIndexBuffer(2, thirdLineBuf);
}


void deinit() 
{

}




int imade=0, made=0;



void start() 
{
 int todo=Bars-made;
 if (todo==0) return(-1);
 made+=todo;

 double h, l;
 int in, i, g, p;
 
 for (i=todo-1;i>=-builtinShift;i--)
 {
  imade++;
  
  if (imade<period)
  {
   firstLineBuf[i]=Open[i]; 
   secondLineBuf[i]=Open[i]; 
   thirdLineBuf[i]=Open[i]; 
  }
  else
  {
   p=period+i;if (p>period) p=period;
   in=i;if (in<0) in=0;
  
   l=iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, p, in));
   h=iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, p, in));
   
   firstLineBuf[i+builtinShift]=l+(h-l)*(2.0/3.0);
   secondLineBuf[i+builtinShift]=l+(h-l)*(1.0/3.0);
   thirdLineBuf[i]=Close[i+1]+(Close[i+1]-Close[i+2])*0.618;
  }
 }
}




